library(class)
library(gmodels)

# knn_k = 20

normalize <- function(x) {
  +     return ((x - min(x)) / (max(x) - min(x))) }
# To normalize the data from 0-1 in order to obtain true Euclidian Distance

setwd("~/Desktop/code.fun.do")
data <- read.csv("bc_dataset.csv", header = F, na.strings = "?")
data <- data[, -1] # Removing the useless id column from the data
for(i in 1:dim(data)[2]){data[,i][is.na(data[,i])] <- mean(data[,i], na.rm = TRUE) } # Replacing the missing values in the data by the respected means of the columns

# data_n <- as.data.frame(lapply(data[1:dim(data)[2]-1], normalize)) # Normalized Data
data_n <- data[, 1:dim(data)[2]-1]
data_train <- data_n[1:400, ]
data_test <- data_n[401:699, ]
data_train_labels <- data[1:400, dim(data)[2]]
data_test_labels <- data[401:699, dim(data)[2]]

for (knn_k in 1:40) {
  print(knn_k)
  data_test_pred <- knn(train = data_train, test = data_test, cl = data_train_labels, k = knn_k) # The predicted values
  CrossTable(x = data_test_labels, y = data_test_pred, prop.chisq = F) # To check the Model
}
